#!/usr/bin/python

# converte una sequenza di parole in una sequenza di numeri, dove ad ogni parola viene associato un id numerico univoco. Le parole vengono considerate tutte lower case
# fornisce:
#	Feeds_Number.txt: file che contiene i feeds usando gli id numerici  
#	cv_string_number.txt: file che contiene l'associazione parola id nel seguente formato:
#		per ogni linea abbiamo parole:id


import sys,string

#crei la hash table
conversion_table={}

#controlli il numero di parametri immessi. 
argv=None
#print len(sys.argv)
if len(sys.argv) == 2:
        argv = sys.argv
else:
	print "Wrong Number of Parameters "
        print "Usage: "
       	print "python nomefile.py file_data "
        sys.exit()

#apro il file in ingresso
try:
        filename = argv[1]
        text = open(filename, 'r')

except IOError:
	print 'Cannot open file '+filename+' for reading'
        sys.exit(0)

#creo il file di uscita
out_file=open('Number_'+filename,'w')

#inizio a leggere il fiel ininput line by line
blanklines=0
count_words=0
count=0
for line in text:
	count+=1
	#controllo che la linea nn sia vuota
	if line.startswith('\n'):
		print("empty line "+str(count))
         	blanklines += 1
	else:
		#se nn e' vuota divido la linea in parole separandola usando gli spazi
		words=line.split(None)
		for w in words:
			#analizzo le singole parole, convertendole da upper case a lower case
			w_l=string.lower(w.split('\n')[0])
			#controllo che la parola nn sia gia' presente nella hash	
			if (not(conversion_table.__contains__(w_l))):
				#se nn e' presente la aggiungo
				conversion_table[w_l]=(conversion_table.__len__())+1
				n_w=str((conversion_table.__len__()))#+' '+w_l
				
			else:
				#se e' presente prendo l'id nuemrico associato	
				n_w=conversion_table.get(w_l)
			#scrivo sul fiel di output l'id numerico				
			out_file.write(str(n_w)+' ')
	#vado a capo alla fine di ogni linea
	out_file.write('\n')
out_file.close()

#scrivo la hash sul file delle conversioni
conv_file=open('map_string_number_'+filename,'w')
for k,v in conversion_table.iteritems(): conv_file.write(str(k)+':'+str(v)+'\n')
conv_file.close()
